/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.doubleclickbidmanager.model;

import com.google.api.client.json.GenericJson;

/**
 * Represents a report.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the DoubleClick Bid Manager API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Report extends GenericJson {

  /**
   * Key used to identify a report.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ReportKey key;

  /**
   * Report metadata.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ReportMetadata metadata;

  /**
   * Report parameters.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Parameters params;

  /**
   * Key used to identify a report.
   * The value returned may be {@code null}.
   */
  public ReportKey getKey() {
    return key;
  }

  /**
   * Key used to identify a report.
   * The value set may be {@code null}.
   */
  public Report setKey(ReportKey key) {
    this.key = key;
    return this;
  }

  /**
   * Report metadata.
   * The value returned may be {@code null}.
   */
  public ReportMetadata getMetadata() {
    return metadata;
  }

  /**
   * Report metadata.
   * The value set may be {@code null}.
   */
  public Report setMetadata(ReportMetadata metadata) {
    this.metadata = metadata;
    return this;
  }

  /**
   * Report parameters.
   * The value returned may be {@code null}.
   */
  public Parameters getParams() {
    return params;
  }

  /**
   * Report parameters.
   * The value set may be {@code null}.
   */
  public Report setParams(Parameters params) {
    this.params = params;
    return this;
  }

}
